OrderedEnvir2 : OrderedEnvir {
	var <count=0;
	*new { arg envir;
		^super.newCopyArgs(
			envir ?? { Environment.new(32, Environment.new) },
			TwoWayIdentityDictionary.new // key <-> index
		) 
	}
	
	put { arg key, val;
		envir.put(key, val);
		order.put(key, count);
		count = count + 1;
	}
	
	at { arg key; ^envir.at(key) }
	
	removeAt { arg key;
		var res = envir.at(key);
		res !? { order.remove(res) }
		^res
	}
	
	keysValuesDo { arg function;
		order.doNodes { arg node, i;
			function.value(node.key, node.obj, i)
		}
	}
		
	keysValuesArrayDo { arg array, function;
		var j=0;
		count.do({ |i|
			var key = order.getID(i);
			key !? { function.value(key, envir.at(key), j); j = j + 1; }
		})
	}
	
	do { arg func;
		var j=0;
		count.do({ |i|
			var key = order.getID(i);
			key !? { func.value(key, envir.at(key), j); j = j + 1; }
		})
	}

}